#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	384
#define	MAXHEIGHT	128

void	readfont(FILE *fontfp,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int width,long int offset,int x,int y);
void	convpic(int picsize_x,int picsize_y,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT]);

int		drawrightsub(int *x,int *y,int *patodd,int col[2][8],int pixel_f[MAXWIDTH][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT]);
int		drawleftsub(int *x,int *y,int *patodd,int col[2][8],int pixel_f[MAXWIDTH][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT]);
int		drawright(int *x,int *y,int *xbuf,int *ybuf,int *patodd,int upflag,int col[2][8],int pixel_f[MAXWIDTH][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT]);
int		drawleft(int *x,int *y,int *xbuf,int *ybuf,int *patodd,int upflag,int col[2][8],int pixel_f[MAXWIDTH][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*fontfp;

	int		pixel[MAXWIDTH][MAXHEIGHT];
	int		pixel_f[MAXWIDTH][MAXHEIGHT];
	int		c_pixel[MAXWIDTH/2][MAXHEIGHT];

	int		width,height;
	int		a0,a1,a2,a3,a4,a5,a6,a7;
	int		a8,a9,a10,a11,a12,a13,a14,a15;
	int		x,y;
	int		i,j;
	int		sht;
	int		vadd;
	int		col[2][8];
	int		div51,div52,patg,patr,patb;
	int		upflag,cflag;
	int		xbuf,ybuf,patodd;
	int		xpush,ypush,patoddpush;
	int		outhigh,eqlen,deqlen,teqlen,qeqlen,seqlen,oeqlen;
	int		outdt4b;
	int		d0,d1;
	int		t_flag;

	int		pat[2][5][8] = {
		{
			{0,0,0,0,0,0,0,0},	// 0x00
			{0,0,0,1,0,0,0,1},	// 0x11
			{0,1,0,1,0,1,0,1},	// 0x55
			{0,1,1,1,0,1,1,1},	// 0x77
			{1,1,1,1,1,1,1,1}	// 0xff
		},{
			{0,0,0,0,0,0,0,0},	// 0x00
			{0,1,0,0,0,1,0,0},	// 0x44
			{1,0,1,0,1,0,1,0},	// 0xaa
			{1,1,0,1,1,1,0,1},	// 0xdd
			{1,1,1,1,1,1,1,1}	// 0xff
		}
	};


	if (argc != 3 && argc != 4) {
		fprintf(stderr, "Usage: convpict infile outfile [fontfile]\n");
		exit(1);
	}

	t_flag = ( (argc == 4) ? 1 : 0);

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if (t_flag != 0) {
		if ((fontfp = fopen(argv[3], "rb")) == NULL) {
			perror(argv[3]);
			exit(1);
		}
	}

	height = 128;
	width = 384;

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	fgetc(infp);
	fgetc(infp);
	fgetc(infp);
	fgetc(infp);

	x = 0;
	for (y = 0;y < height;) {
		a0 = fgetc(infp);

		if (a0 == 0x00 || a0 == 0xff) {

			a1 = fgetc(infp);

			for (j = 0;j < a1;j ++) {
				sht = 0x80;
				for (i = 0;i < 8;i ++) {
					if ( (a0 & sht) != 0) {
						pixel[x+i][y] = 0x0f;
					} else {
						pixel[x+i][y] = 0x08;
					}
					sht /= 2;
				}
				x += 8;
				if (x >= width) {
					x = 0;
					y ++;
				}
			}

		} else {

			sht = 0x80;
			for (i = 0;i < 8;i ++) {
				if ( (a0 & sht) != 0) {
					pixel[x+i][y] = 0x0f;
				} else {
					pixel[x+i][y] = 0x08;
				}
				sht /= 2;
			}
			x += 8;
			if (x >= width) {
				x = 0;
				y ++;
			}
		}
	}

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel_f[x][y] = pixel[x][y];
		}
	}


	for (;;) {

		a0 = fgetc(infp);				// N_VRAMAhXiʁj
		a1 = fgetc(infp);				// N_VRAMAhXiʁj
		if (a0 == 0xff && a1 == 0xff) {
			break;
		}

		a2 = fgetc(infp);				// N_rbgi0x80A0x40AA0x01j
		a3 = fgetc(infp);				// p^[ԍ

		if ( (a1 & 0x80) != 0x00) {
			patodd = 0;
			a1 &= 0x7f;
		} else {
			patodd = 1;
		}

// N_XYWZo
		vadd = a0 + a1*0x100;
		y = vadd/80;
		x = (vadd%80)*8 - 128;

		switch (a2) {
			case 0x80: x+= 0; break;
			case 0x40: x+= 1; break;
			case 0x20: x+= 2; break;
			case 0x10: x+= 3; break;
			case 0x08: x+= 4; break;
			case 0x04: x+= 5; break;
			case 0x02: x+= 6; break;
			case 0x01: x+= 7; break;
			default:
				fprintf(stderr, "Illigal startbit\n");
				exit(1);
		}

// p^[Zo
		div51 = a3/5;
		patb  = a3%5;
		div52 = div51/5;
		patr  = div51%5;
		patg  = div52%5;

		for (i = 0;i < 8;i ++) {
			col[0][i]  = 0x08;
			col[0][i] |= (pat[0][patg][i] * 0x04);
			col[0][i] |= (pat[0][patr][i] * 0x02);
			col[0][i] |= (pat[0][patb][i] * 0x01);
			col[1][i]  = 0x08;
			col[1][i] |= (pat[1][patg][i] * 0x04);
			col[1][i] |= (pat[1][patr][i] * 0x02);
			col[1][i] |= (pat[1][patb][i] * 0x01);
		}

/* h */
/*

P|OjzVRAMAN_rbgۑi0x9C37`9jA^ۑi0x9C36jAWX^ۑ
P|Pjɐݒ
	P|Qj(0x9111)iE֓hj

		P|Rj(0x9167)iE֓hj
		P|R|PjN_hĂAgizVRAM̓e0x08jȂCflag=1A^[
		P|R|QjN_EɓhihĂAg܂Łj
		P|R|RjhĂAgɓBACflag=0A^[

	P|Q|PjCflag=1iN_hĂꍇjȂ烊^[
	P|Q|Qj^ɋN_̍sړ
	P|Q|Rj^ς
	P|Q|SjN_hĂȂP|Q|10jփWv
	P|Q|TjzVRAMAN_rbgۑi0x9C37`9j
	P|Q|UjN_EɈړ

		P|Sj(0x9167)iE֓hj
		P|S|PjN_hĂAgizVRAM̓e0x08jȂCflag=1A^[
		P|S|QjN_EɓhihĂAg܂Łj
		P|S|RjhĂAgɓBACflag=0A^[

	P|Q|VjCflag=1iN_hĂꍇjȂ烊^[iN_͂P|Q|TƓj
	P|Q|WjzVRAMAN_rbgۑi0x9C37`9j
	P|Q|XjN_P|Q|Tɖ߂ACflag=0Ń^[

	P|Q|10jN_AۑN_̏^i0x9C37`9j܂ŁAhĂȂӏT
	P|Q|11j΁AŏɌN_ɂAɂ̏ꏊۑi0x9C37`9j
	P|Q|12jȂ΁ACflag=1Ń^[

P|TjCflag=1ȂAQ|Pj
@P|Uj(0x91D7)i֓hj

P|VjCflag=1ȂAQ|Pj
P|WjP|PjփWv


Q|PjP|OjŕۑN_A^ǂݏoAꂼꃏ[Nɕۑ
Q|QjN_ɂ
Q|Rjɐݒ
Q|Sj(0x91D7)i֓hj
Q|TjCflag=1ȂAI
P|Uj(0x9111)iE֓hj
P|VjCflag=1ȂAI
P|WjQ|RjփWv

*/

		xbuf = x;
		ybuf = y;
		upflag = 1;

		xpush = x;
		ypush = y;
		patoddpush = patodd;

		for (;;) {
			cflag = drawright(&x,&y,&xbuf,&ybuf,&patodd,upflag,col,pixel_f,pixel);	// 0x9111
			if (cflag == 1) {
				break;
			}
			cflag = drawleft(&x,&y,&xbuf,&ybuf,&patodd,upflag,col,pixel_f,pixel);	// 0x91D7
			if (cflag == 1) {
				break;
			}
		}

		x = xpush;
		y = ypush;
		patodd = patoddpush;
		xbuf = x;
		ybuf = y;
		x --;
		upflag = 0;

		for (;;) {
			cflag = drawleft(&x,&y,&xbuf,&ybuf,&patodd,upflag,col,pixel_f,pixel);	// 0x91D7
			if (cflag == 1) {
				break;
			}
			cflag = drawright(&x,&y,&xbuf,&ybuf,&patodd,upflag,col,pixel_f,pixel);	// 0x9111
			if (cflag == 1) {
				break;
			}
		}

	}


/*
	for (y = height-1;y >= 0;y --) {
		for (i = 0;i < 2;i ++) {
			for (x = 0;x < width;x += 2) {
				a0 = (pixel[x][y] & 0x0f) << 4;
				a1 = (pixel[x+1][y] & 0x0f);
				fputc(a0|a1, outfp);
			}
		}
	}
*/

	convpic(width,height,c_pixel,pixel);


/* ^Cgǂ߂悤ɏC */

	if (t_flag != 0) {
		readfont(fontfp,c_pixel,8,0x0a80, 80, 11);	/*  */
		readfont(fontfp,c_pixel,8,0x0a00, 95, 11);	/*  */

		readfont(fontfp,c_pixel,8,0x0080,  8, 43);	/* @ */
		readfont(fontfp,c_pixel,8,0x0080,  9, 41);	/* @ */
		readfont(fontfp,c_pixel,8,0x0080, 33, 41);	/* @ */
		readfont(fontfp,c_pixel,8,0x0080, 41, 41);	/* @ */
		readfont(fontfp,c_pixel,8,0x0080, 70, 41);	/* @ */
		readfont(fontfp,c_pixel,8,0x0080, 86, 41);	/* @ */
		readfont(fontfp,c_pixel,8,0x0080, 94, 41);	/* @ */
		readfont(fontfp,c_pixel,8,0x2900,  9, 43);	/*  */
		readfont(fontfp,c_pixel,8,0x2308, 17, 43);	/*  */
		readfont(fontfp,c_pixel,8,0x00a8, 25, 43);	/* E */
		readfont(fontfp,c_pixel,8,0x4a30, 33, 43);	/*  */
		readfont(fontfp,c_pixel,8,0x3ab8, 41, 43);	/*  */
		readfont(fontfp,c_pixel,8,0x58f0, 70, 43);	/* J */
		readfont(fontfp,c_pixel,8,0x7080, 78, 43);	/* L */
		readfont(fontfp,c_pixel,8,0x7188, 86, 43);	/* m */
		readfont(fontfp,c_pixel,8,0x4a58, 94, 43);	/*  */

		readfont(fontfp,c_pixel,8,0x0080, 50, 53);	/* @ */
		readfont(fontfp,c_pixel,8,0x00d0, 14, 52);	/* J */
		readfont(fontfp,c_pixel,8,0x0cb0,  8, 53);	/* N */
		readfont(fontfp,c_pixel,8,0x0e80, 16, 53);	/*  */
		readfont(fontfp,c_pixel,8,0x0de0, 24, 53);	/* t */
		readfont(fontfp,c_pixel,8,0x0c50, 32, 53);	/* B */
		readfont(fontfp,c_pixel,8,0x0d50, 40, 53);	/* b */
		readfont(fontfp,c_pixel,8,0x0cb0, 48, 53);	/* N */
		readfont(fontfp,c_pixel,8,0x0820, 78, 53);	/* x */
		readfont(fontfp,c_pixel,8,0x4860, 86, 53);	/* l */

		readfont(fontfp,c_pixel,8,0x0080, 92, 63);	/* @ */
		readfont(fontfp,c_pixel,8,0x0788,  8, 63);	/* e */
		readfont(fontfp,c_pixel,8,0x07c0, 16, 63);	/* l */
		readfont(fontfp,c_pixel,8,0x0260, 24, 63);	/* | */
		readfont(fontfp,c_pixel,8,0x0770, 31, 63);	/* b */
		readfont(fontfp,c_pixel,8,0x08d0, 38, 63);	/*  */
		readfont(fontfp,c_pixel,8,0x0878, 44, 63);	/*  */
		readfont(fontfp,c_pixel,8,0x0880, 50, 63);	/*  */
		readfont(fontfp,c_pixel,8,0x0b40, 74, 63);	/*  */
		readfont(fontfp,c_pixel,8,0x0b60, 82, 63);	/*  */
		readfont(fontfp,c_pixel,8,0x0340, 90, 63);	/*  */

		readfont(fontfp,c_pixel,8,0x0080, 24, 88);	/* @ */
		readfont(fontfp,c_pixel,8,0x0080, 52, 88);	/* @ */
		readfont(fontfp,c_pixel,8,0x0080, 86, 90);	/* @ */
		readfont(fontfp,c_pixel,4,0x01cc, 17, 90);	/* i */
		readfont(fontfp,c_pixel,2,0x0871, 21, 90);	/*  */
		readfont(fontfp,c_pixel,3,0x0874, 23, 90);	/*  */
		readfont(fontfp,c_pixel,4,0x01d0, 26, 90);	/* j */
		readfont(fontfp,c_pixel,4,0x06e1, 30, 90);	/* P */
		readfont(fontfp,c_pixel,2,0x0720, 34, 90);	/* X */
		readfont(fontfp,c_pixel,3,0x0724, 36, 90);	/* X */
		readfont(fontfp,c_pixel,2,0x0718, 39, 90);	/* W */
		readfont(fontfp,c_pixel,3,0x071c, 41, 90);	/* W */
		readfont(fontfp,c_pixel,2,0x0700, 44, 90);	/* T */
		readfont(fontfp,c_pixel,3,0x0704, 46, 90);	/* T */
		readfont(fontfp,c_pixel,8,0x5800, 52, 90);	/*  */
		readfont(fontfp,c_pixel,8,0x37e0, 60, 90);	/*  */
		readfont(fontfp,c_pixel,8,0x0d20, 68, 90);	/* \ */
		readfont(fontfp,c_pixel,8,0x0de0, 76, 90);	/* t */
		readfont(fontfp,c_pixel,8,0x0d78, 84, 90);	/* g */
	}

/*
	for (y = height-1;y >= 0;y --) {
		for (i = 0;i < 2;i ++) {
			for (x = 0;x < width/2;x ++) {
				a0 = (c_pixel[x][y] & 0x0f) << 4;
				a1 = (c_pixel[x][y] & 0x0f);
				fputc(a0|a1, outfp);
			}
		}
	}
*/



/* f[^k */
/*
Ef[^́ASrbgP
E1st 0x8 ȏȂÂ܂܂̃f[^

E1st 0x0 Ȃ 1oCgk
E2nd 0x4`0xF ȂA3rd 2nd JԂ
E2nd 0x0 ȂA3rd  31 JԂ
E2nd 0x1 ȂA3rd  63 JԂ
E2nd 0x2 ȂA3rd  127 JԂ
E2nd 0x3 ȂA3rd  255 JԂ

E1st 0x1`0x7 Ȃ 2/3/4/6/8oCgk
E1st 0x2`0x7 ȂA2nd (,3rd (,4th,5th,(6th,7th,(8th,9th))))1stJԂ
E1st 0x1 ȂA2nd (,3rd (,4th,5th,(6th,7th,(8th,9th))))16JԂ
E2ndA0x8`0xfA3rdA0x8`0xfȂA2oCgkB
E2ndA0x8`0xfA3rdA0x0`0x7ȂA3oCgkBJԂf[^́A3rd+8
E2ndA0x0`0x7A3rdA0x8`0xfȂA4oCgkBJԂf[^́A2nd+8
E2ndA0x0`0x7A3rdA0x0`0x7ȂA6oCgkBJԂf[^́A2ndA3rd+8
E2nd`4thA0x0`0x7ȂA8oCgkBJԂf[^́A2ndA3rdA4th+8

EPŊBSrbgPʂŗ]ꍇ́AŌ 0x0 𖄂߂B
*/

	for (y = 0;y < height;y ++) {
		outhigh = 1;
		for (x = 0;x < width/2;) {

		// oCǧo
			eqlen = 0;
			a0 = c_pixel[x][y];
			for (i = x;i < width/2;i ++) {
				a1 = c_pixel[i][y];
				if (a0 != a1) {
					break;
				}
				eqlen ++;
			}

		// QoCgǍo
			deqlen = 0;
			if (x < width/2-1) {
				a0 = c_pixel[x+0][y];
				a1 = c_pixel[x+1][y];
				for (i = x;i < width/2-1;i +=2) {
					a2 = c_pixel[i+0][y];
					a3 = c_pixel[i+1][y];
					if (a0 != a2 || a1 != a3) {
						break;
					}
					deqlen ++;
				}
			}

		// RoCgǍo
			teqlen = 0;
			if (x < width/2-2) {
				a0 = c_pixel[x+0][y];
				a1 = c_pixel[x+1][y];
				a2 = c_pixel[x+2][y];
				for (i = x;i < width/2-2;i +=3) {
					a3 = c_pixel[i+0][y];
					a4 = c_pixel[i+1][y];
					a5 = c_pixel[i+2][y];
					if (a0 != a3 || a1 != a4 || a2 != a5) {
						break;
					}
					teqlen ++;
				}
			}

		// SoCgǍo
			qeqlen = 0;
			if (x < width/2-3) {
				a0 = c_pixel[x+0][y];
				a1 = c_pixel[x+1][y];
				a2 = c_pixel[x+2][y];
				a3 = c_pixel[x+3][y];
				for (i = x;i < width/2-3;i +=4) {
					a4 = c_pixel[i+0][y];
					a5 = c_pixel[i+1][y];
					a6 = c_pixel[i+2][y];
					a7 = c_pixel[i+3][y];
					if (a0 != a4 || a1 != a5 || a2 != a6 || a3 != a7) {
						break;
					}
					qeqlen ++;
				}
			}

		// UoCgǍo
			seqlen = 0;
			if (x < width/2-5) {
				a0 = c_pixel[x+0][y];
				a1 = c_pixel[x+1][y];
				a2 = c_pixel[x+2][y];
				a3 = c_pixel[x+3][y];
				a4 = c_pixel[x+4][y];
				a5 = c_pixel[x+5][y];
				for (i = x;i < width/2-5;i +=6) {
					a8  = c_pixel[i+0][y];
					a9  = c_pixel[i+1][y];
					a10 = c_pixel[i+2][y];
					a11 = c_pixel[i+3][y];
					a12 = c_pixel[i+4][y];
					a13 = c_pixel[i+5][y];
					if (
						a0 !=  a8 || a1 !=  a9 || a2 != a10 || a3 != a11 ||
						a4 != a12 || a5 != a13
					) {
						break;
					}
					seqlen ++;
				}
			}

		// WoCgǍo
			oeqlen = 0;
			if (x < width/2-7) {
				a0 = c_pixel[x+0][y];
				a1 = c_pixel[x+1][y];
				a2 = c_pixel[x+2][y];
				a3 = c_pixel[x+3][y];
				a4 = c_pixel[x+4][y];
				a5 = c_pixel[x+5][y];
				a6 = c_pixel[x+6][y];
				a7 = c_pixel[x+7][y];
				for (i = x;i < width/2-7;i +=8) {
					a8  = c_pixel[i+0][y];
					a9  = c_pixel[i+1][y];
					a10 = c_pixel[i+2][y];
					a11 = c_pixel[i+3][y];
					a12 = c_pixel[i+4][y];
					a13 = c_pixel[i+5][y];
					a14 = c_pixel[i+6][y];
					a15 = c_pixel[i+7][y];
					if (
						a0 !=  a8 || a1 !=  a9 || a2 != a10 || a3 != a11 ||
						a4 != a12 || a5 != a13 || a6 != a14 || a7 != a15
					) {
						break;
					}
					oeqlen ++;
				}
			}


			if (oeqlen >= 2 && eqlen < oeqlen*8 && deqlen < oeqlen*4 && teqlen < oeqlen*3 && qeqlen < oeqlen*2 && seqlen < oeqlen) {
					// WoCgk

				if (oeqlen >= 15) {
					outdt4b = 0x01;
					x += 15*8;
				} else if (oeqlen >= 7) {
					outdt4b = 0x07;
					x += 7*8;
				} else {
					outdt4b = oeqlen;
					x += oeqlen*8;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a2-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a3;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a4;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a5;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a6;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a7;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else if (seqlen >= 2 && eqlen < seqlen*6 && deqlen < seqlen*3 && teqlen < seqlen*2 && qeqlen < seqlen) {
					// UoCgk

				if (seqlen >= 15) {
					outdt4b = 0x01;
					x += 15*6;
				} else if (seqlen >= 7) {
					outdt4b = 0x07;
					x += 7*6;
				} else {
					outdt4b = seqlen;
					x += seqlen*6;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a2;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a3;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a4;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a5;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else if (qeqlen >= 2 && eqlen < qeqlen*4 && deqlen < qeqlen*2 && teqlen < qeqlen) {
					// SoCgk

				if (qeqlen >= 15) {
					outdt4b = 0x01;
					x += 15*4;
				} else if (qeqlen >= 7) {
					outdt4b = 0x07;
					x += 7*4;
				} else {
					outdt4b = qeqlen;
					x += qeqlen*4;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a2;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a3;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else if (teqlen >= 2 && eqlen < teqlen*3 && deqlen < teqlen) {	// RoCgk

				if (teqlen >= 15) {
					outdt4b = 0x01;
					x += 15*3;
				} else if (teqlen >= 7) {
					outdt4b = 0x07;
					x += 7*3;
				} else {
					outdt4b = teqlen;
					x += teqlen*3;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a2;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}


			} else if (deqlen >= 2 && eqlen < deqlen*2) {		// QoCgk

				if (deqlen >= 15) {
					outdt4b = 0x01;
					x += 15*2;
				} else if (deqlen >= 7) {
					outdt4b = 0x07;
					x += 7*2;
				} else {
					outdt4b = deqlen;
					x += deqlen*2;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}


			} else if (eqlen >= 4) {		// PoCgk

				outdt4b = 0x00;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				if (eqlen >= 255) {
					outdt4b = 0x03;
					x += 255;
				} else if (eqlen >= 127) {
					outdt4b = 0x02;
					x += 127;
				} else if (eqlen >= 63) {
					outdt4b = 0x01;
					x += 63;
				} else if (eqlen >= 31) {
					outdt4b = 0x00;
					x += 31;
				} else if (eqlen >= 15) {
					outdt4b = 0x0f;
					x += 15;
				} else {
					outdt4b = eqlen;
					x += eqlen;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else {					// kȂ

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}
				x ++;

			}

		}

		outdt4b = 0x00;
		if (outhigh != 1) {
			d1 = (outdt4b & 0x0f);
			fputc(d0|d1,outfp);
		}

	}


	fclose(outfp);
	fclose(infp);

	return(0);
}

void	readfont(FILE *fontfp,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int width,long int offset,int x,int y)
{
	int		i,ix,iy;
	int		f0;
	int		sft;

	fseek(fontfp,offset,SEEK_SET);

	for (ix = 0;ix < width;ix ++) {
		f0 = fgetc(fontfp);

		sft = 0x01;
		for (iy = 0;iy < 8;iy ++) {
			c_pixel[x+ix][y+iy] = ( ((f0 & sft) != 0x00) ? 0x08 : 0x0d);
			sft *= 2;
		}
	}

	return;
}

int		drawrightsub(int *x,int *y,int *patodd,int col[2][8],int pixel_f[MAXWIDTH][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT])
{
	int		cflag;
	int		ix;

	cflag = 1;
	for (ix = *x;pixel_f[ix][*y] == 0x0f;ix ++) {
		cflag = 0;
		pixel_f[ix][*y] = 0x08;
		pixel[ix][*y] = col[*patodd][ix%8];
		*x = ix;
	}

	return cflag;
}

int		drawleftsub(int *x,int *y,int *patodd,int col[2][8],int pixel_f[MAXWIDTH][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT])
{
	int		cflag;
	int		ix;

	cflag = 1;
	for (ix = *x;pixel_f[ix][*y] == 0x0f;ix --) {
		cflag = 0;
		pixel_f[ix][*y] = 0x08;
		pixel[ix][*y] = col[*patodd][ix%8];
		*x = ix;
	}

	return cflag;
}


int		drawright(int *x,int *y,int *xbuf,int *ybuf,int *patodd,int upflag,int col[2][8],int pixel_f[MAXWIDTH][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT])
{
	int		cflag;
	int		ix;
	int		xpush,ypush;

	cflag = drawrightsub(x,y,patodd,col,pixel_f,pixel);	// 0x9167

	if (cflag == 1) {
		return cflag;
	}

	if (upflag == 1) {
		(*y) --;
	} else {
		(*y) ++;
	}

	if (*patodd == 0) {
		*patodd = 1;
	} else {
		*patodd = 0;
	}

	if (pixel_f[*x][*y] == 0x0f) {
		*xbuf = *x;
		*ybuf = *y;
		xpush = *x;
		ypush = *y;
		(*x) ++;

		cflag = drawrightsub(x,y,patodd,col,pixel_f,pixel);

		if (cflag == 0) {
			*xbuf = *x;
			*ybuf = *y;
		}
		*x = xpush;
		*y = ypush;
		cflag = 0;

	} else {

		cflag = 1;
		for (ix = *x;ix >= *xbuf;ix --) {
			if (pixel_f[ix][*y] == 0x0f) {
				cflag = 0;
				break;
			}
		}
		*x = ix;

		if (cflag == 0) {
			*xbuf = *x;
			*ybuf = *y;
		}

	}
	return cflag;

}

int		drawleft(int *x,int *y,int *xbuf,int *ybuf,int *patodd,int upflag,int col[2][8],int pixel_f[MAXWIDTH][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT])
{
	int		cflag;
	int		ix;
	int		xpush,ypush;

	cflag = drawleftsub(x,y,patodd,col,pixel_f,pixel);	// 0x922D

	if (cflag == 1) {
		return cflag;
	}

	if (upflag == 1) {
		(*y) --;
	} else {
		(*y) ++;
	}

	if (*patodd == 0) {
		*patodd = 1;
	} else {
		*patodd = 0;
	}

	if (pixel_f[*x][*y] == 0x0f) {
		*xbuf = *x;
		*ybuf = *y;
		xpush = *x;
		ypush = *y;
		(*x) --;

		cflag = drawleftsub(x,y,patodd,col,pixel_f,pixel);

		if (cflag == 0) {
			*xbuf = *x;
			*ybuf = *y;
		}
		*x = xpush;
		*y = ypush;
		cflag = 0;

	} else {

		cflag = 1;
		for (ix = *x;ix <= *xbuf;ix ++) {
			if (pixel_f[ix][*y] == 0x0f) {
				cflag = 0;
				break;
			}
		}
		*x = ix;

		if (cflag == 0) {
			*xbuf = *x;
			*ybuf = *y;
		}

	}
	return cflag;

}


void	convpic(int picsize_x,int picsize_y,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT])
{
	int		x,y;

	int		c_pixel_tmp[MAXWIDTH/2][MAXHEIGHT];

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel[x+0][y] = pixel[x*2+0][y];
		}

		for (x = 0;x < picsize_x/2 - 2;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+2][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+3][y])
			) {
				if ( (x%2) == 0) {
					c_pixel[x+0][y] = pixel[x*2+0][y];
					c_pixel[x+1][y] = pixel[x*2+1][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2+1][y];
					c_pixel[x+1][y] = pixel[x*2+0][y];
				}
			}
		}
		for (;x < picsize_x/2;x ++) {
			if (
				(pixel[x*2-2+0][y] == pixel[x*2-2+2][y]) && 
				(pixel[x*2-2+1][y] == pixel[x*2-2+3][y])
			) {
				if ( (x%2) == 0) {
					c_pixel[x+0][y] = pixel[x*2-2+0][y];
					c_pixel[x+1][y] = pixel[x*2-2+1][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2-2+1][y];
					c_pixel[x+1][y] = pixel[x*2-2+0][y];
				}
			}
		}

		for (x = 0;x < picsize_x/2 - 4;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+4][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+5][y]) &&
				(pixel[x*2+2][y] == pixel[x*2+6][y]) && 
				(pixel[x*2+3][y] == pixel[x*2+7][y])
			) {
				if ( (x%4) == 0) {
					c_pixel[x+0][y] = pixel[x*2+0][y];
					c_pixel[x+1][y] = pixel[x*2+1][y];
					c_pixel[x+2][y] = pixel[x*2+2][y];
					c_pixel[x+3][y] = pixel[x*2+3][y];
				} else if ( (x%4) == 1) {
					c_pixel[x+0][y] = pixel[x*2+3][y];
					c_pixel[x+1][y] = pixel[x*2+0][y];
					c_pixel[x+2][y] = pixel[x*2+1][y];
					c_pixel[x+3][y] = pixel[x*2+2][y];
				} else if ( (x%4) == 2) {
					c_pixel[x+0][y] = pixel[x*2+2][y];
					c_pixel[x+1][y] = pixel[x*2+3][y];
					c_pixel[x+2][y] = pixel[x*2+0][y];
					c_pixel[x+3][y] = pixel[x*2+1][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2+1][y];
					c_pixel[x+1][y] = pixel[x*2+2][y];
					c_pixel[x+2][y] = pixel[x*2+3][y];
					c_pixel[x+3][y] = pixel[x*2+0][y];
				}
			}
		}
		for (;x < picsize_x/2;x ++) {
			if (
				(pixel[x*2-4+0][y] == pixel[x*2-4+4][y]) && 
				(pixel[x*2-4+1][y] == pixel[x*2-4+5][y]) &&
				(pixel[x*2-4+2][y] == pixel[x*2-4+6][y]) && 
				(pixel[x*2-4+3][y] == pixel[x*2-4+7][y])
			) {
				if ( (x%4) == 0) {
					c_pixel[x+0][y] = pixel[x*2-4+0][y];
					c_pixel[x+1][y] = pixel[x*2-4+1][y];
					c_pixel[x+2][y] = pixel[x*2-4+2][y];
					c_pixel[x+3][y] = pixel[x*2-4+3][y];
				} else if ( (x%4) == 1) {
					c_pixel[x+0][y] = pixel[x*2-4+3][y];
					c_pixel[x+1][y] = pixel[x*2-4+0][y];
					c_pixel[x+2][y] = pixel[x*2-4+1][y];
					c_pixel[x+3][y] = pixel[x*2-4+2][y];
				} else if ( (x%4) == 2) {
					c_pixel[x+0][y] = pixel[x*2-4+2][y];
					c_pixel[x+1][y] = pixel[x*2-4+3][y];
					c_pixel[x+2][y] = pixel[x*2-4+0][y];
					c_pixel[x+3][y] = pixel[x*2-4+1][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2-4+1][y];
					c_pixel[x+1][y] = pixel[x*2-4+2][y];
					c_pixel[x+2][y] = pixel[x*2-4+3][y];
					c_pixel[x+3][y] = pixel[x*2-4+0][y];
				}
			}
		}

	}

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel_tmp[x][y] = c_pixel[x][y];
		}
	}

	for (y = 1;y < picsize_y;y += 2) {
		for (x = 0;x < picsize_x/2 - 3;x ++) {

			if (
				(c_pixel_tmp[x+0][y-0] == c_pixel_tmp[x+2][y-0]) &&
				(c_pixel_tmp[x+1][y-0] == c_pixel_tmp[x+3][y-0]) &&
				(c_pixel_tmp[x+0][y-1] == c_pixel_tmp[x+2][y-1]) &&
				(c_pixel_tmp[x+1][y-1] == c_pixel_tmp[x+3][y-1]) &&
				( (c_pixel_tmp[x+0][y-0] == c_pixel_tmp[x+0][y-1]) ||
				  (c_pixel_tmp[x+1][y-0] == c_pixel_tmp[x+1][y-1]) 
				)
			) {
				c_pixel[x+0][y] = c_pixel_tmp[x+1][y];
				c_pixel[x+1][y] = c_pixel_tmp[x+0][y];
				c_pixel[x+2][y] = c_pixel_tmp[x+3][y];
				c_pixel[x+3][y] = c_pixel_tmp[x+2][y];
			}

		}
	}

	return;
}


